import java.io.*;
import java.util.*;
import org.dom4j.*;
import org.dom4j.io.*;

/*************************************************************************
 *  Tento kd tdy vezmte, doplte tla metod <code>adjustSalary</code>, 
 *  <code>changeName</code> a <code>getWageCosts</code>.
 *  S ostatnmi nedlejte nic.
 *  Po doplnn by mla fungovat metoda <code>main</code> tak, jak je.
 *  Pro peklad a sputn mete vyut skript build.xml.
 *
 *  Kompletn balek <code>dom4j</code> sthnete z <code>http://dom4j.org</code>,
 *  zde z dvodu spory msta najdete jen <code>dom4j.jar</code>, kter ale pro peklad
 *  i bh sta.
 */
public class Uloha2 {

  /** dom4j object model representation of a xml document. Note: We use the interface(!) not its implementation */
  private Document doc;

  /**
   * Loads a document from a file.
   *
   * @throw a org.dom4j.DocumentException occurs whenever the buildprocess fails.
   */
  public void parseWithSAX(File aFile) throws DocumentException, java.net.MalformedURLException {
    SAXReader xmlReader = new SAXReader();
    this.doc = xmlReader.read(aFile);
  }
  
  public void serializetoXML(OutputStream out, String aEncodingScheme) throws Exception {
    OutputFormat outformat = OutputFormat.createPrettyPrint();
    outformat.setEncoding(aEncodingScheme);
    XMLWriter writer = new XMLWriter(out, outformat);
    writer.write(this.doc);
    writer.flush();
  }
 
  /*************************************************************************
   *  Metoda na pravu plat:
   *  M-li osoba men plat ne <code>minimum</code>, 
   *  bude j plat zven na <code>minimum</code>.
   *  S ostatnmi osobami se nic nedje.
   */
  public void adjustSalary(float minimum) {
	// sem doplnit kd
	
  }

  /*************************************************************************
   *  Metoda na zmnu jmna:
   *  kter osoba m <code>id</code> rovno zadanmu, 
   *  zmn se j kestn jmno (<code>name</code>) na <code>newName</code>
   *  S ostatnmi se opt nedje nic.
   */
  public void changeName(String id, String newName) {
	// sem doplnit kd
	
  }

  /*************************************************************************
   *  Metoda na spotn mzdovch nklad:
   *  Metoda projde vechny osoby ve vstupnm souboru a sete hodnoty jejich plat.
   */
  public float getWageCosts() {
	// sem doplnit kd
	return 0; // msto 0 vrt souet plat
	
  }
  
  private static final float EXPECTED_WAGE_COSTS_BEFORE_UPDATES = 21000f;
  private static final float EXPECTED_WAGE_COSTS_AFTER_UPDATES = 22000f;
  
  public static void main(String[] args) throws Exception {

	if (args.length < 1) {
	    System.err.println("Chyb argument se jmnem souboru pro zpracovn (uvd se bez ppony '.xml')!");
	}
	
  	Uloha2 uloha2 = new Uloha2();
  	uloha2.parseWithSAX(new File(args[0]+".xml"));

	float wageCosts = uloha2.getWageCosts();
	if (wageCosts != EXPECTED_WAGE_COSTS_BEFORE_UPDATES) {
	    System.err.println("Souet plat nen sprvn (msto " + EXPECTED_WAGE_COSTS_BEFORE_UPDATES + 
		" metoda getWageCosts vrac " + wageCosts + ")");
	}

  	uloha2.changeName("1", "Pavlk");
  	uloha2.changeName("2", "Liborek");
  	uloha2.adjustSalary(10000f);

	wageCosts = uloha2.getWageCosts();
	if (wageCosts != EXPECTED_WAGE_COSTS_AFTER_UPDATES) {
	    System.err.println("Souet plat po jejich prav pomoc metody adjustSalary nen sprvn (msto " + 
		EXPECTED_WAGE_COSTS_AFTER_UPDATES + " metoda getWageCosts vrac " + wageCosts + ")");
	}

  	uloha2.serializetoXML(new FileOutputStream(args[0]+"-out.xml"), "windows-1250");
  }

}

